import {Component, OnInit, ViewChild, ElementRef} from '@angular/core';
import {AlarmService} from '../alarm.service';
import {NzMessageService} from 'ng-zorro-antd';
import {SendLogComponent} from '../modal/send-log/send-log.component';
import {pageSize} from '../../app.constants';
import {WarnListComponent} from '../../modal/warn-list/warn-list.component';

@Component({
    selector: 'smart-now-alarm',
    templateUrl: './now-alarm.component.html',
    styles: [
            `            
        `
    ]
})
export class NowAlarmComponent implements OnInit {
    @ViewChild('sendLog') sendLog:SendLogComponent;
    @ViewChild('warnList') warnList:WarnListComponent;

    loading = false;
    pageCount = pageSize;
    pageNum = 1;
    totalNum;

    constructor(public alarmSer: AlarmService, public message: NzMessageService) {
    }

    ngOnInit() {
        this.search();
    }

    search(){
        const obj = {
            isWaring:'yes'
        }
        this.warnList.getList(obj);
    }

    change(e){
        this.pageNum = e;
    }

    //打开modal
    showModal(data){
        this.sendLog.showModal(data);
    }
}
