import { Component, OnInit } from '@angular/core';
import { SystemService } from "../system.service";
import {
    AbstractControl,
    FormBuilder,
    FormControl,
    FormGroup,
    Validators
} from '@angular/forms';

@Component({
  selector: 'jhi-power',
  templateUrl: './power.component.html',
  styles: []
})
export class PowerComponent implements OnInit {
    dataSet:any[];
    isVisible = false;
    validateForm: FormGroup;
  constructor(private fb: FormBuilder,private systemSer: SystemService) { }

  ngOnInit() {
      this.dataSet = [
          {
              key1 : '角色名称',
              key2 : '说明',
              key3 : '权限模块',
              key4 : '资源权限',
              key5 : '有效'
          },
          {
              key1 : '角色名称',
              key2 : '说明',
              key3 : '权限模块',
              key4 : '资源权限',
              key5 : '有效'
          },
          {
              key1 : '角色名称',
              key2 : '说明',
              key3 : '权限模块',
              key4 : '资源权限',
              key5 : '有效'
          },
          {
              key1 : '角色名称',
              key2 : '说明',
              key3 : '权限模块',
              key4 : '资源权限',
              key5 : '有效'
          },
          {
              key1 : '角色名称',
              key2 : '说明',
              key3 : '权限模块',
              key4 : '资源权限',
              key5 : '有效'
          },
          {
              key1 : '角色名称',
              key2 : '说明',
              key3 : '权限模块',
              key4 : '资源权限',
              key5 : '有效'
          },
      ];
      this.getRole();
      this.validateForm = this.fb.group({
          email            : [ null, [ Validators.email ] ],
          sex            : [ null, [ Validators.required ] ],
          department     : [ null, [ Validators.required ] ],
          password         : [ null, [ Validators.required ] ],
          checkPassword    : [ null, [ Validators.required, this.confirmationValidator ] ],
          nickname         : [ null, [ Validators.required ] ],
          phoneNumber      : [ null, [ Validators.required ] ],
          website          : [ null, [ Validators.required ] ],
          captcha          : [ null, [ Validators.required ] ],
          agree            : [ false ]
      });
  }

    getRole(){
      this.systemSer.role().subscribe(
          (res)=>{
              this.dataSet = res.data;
          }
      )
    }

    showModal(): void {
        this.isVisible = true;
    }

    handleOk(): void {
        this.isVisible = false;
    }

    handleCancel(): void {
        this.isVisible = false;
    }

    submitForm(): void {
        for (const i in this.validateForm.controls) {
            this.validateForm.controls[ i ].markAsDirty();
            this.validateForm.controls[ i ].updateValueAndValidity();
        }
    }

    updateConfirmValidator(): void {
        /** wait for refresh value */
        Promise.resolve().then(() => this.validateForm.controls.checkPassword.updateValueAndValidity());
    }

    confirmationValidator = (control: FormControl): { [s: string]: boolean } => {
        if (!control.value) {
            return { required: true };
        } else if (control.value !== this.validateForm.controls.password.value) {
            return { confirm: true, error: true };
        }
    }

    getCaptcha(e: MouseEvent): void {
        e.preventDefault();
    }

    hello(){
      console.log('hello');
    }

}
